#ifndef _3DCLASS_H_
#define _3DCLASS_H_

#include "3dmath.h"


class Vertex
{
public:
	Vector pos;
	Vector norm;
	unsigned char r, g, b;

	inline Vertex()
	{  r = g = b = 255;  }
	inline Vertex(Vertex &vert)
	{  (*this) = vert;  }
	inline Vertex(float x, float y, float z)
	{  pos.x=x; pos.y=y; pos.z=z; r = g = b = 255;  }

	inline void SetColor(unsigned char R, unsigned char G, unsigned char B)
	{  r = R; g = G; b = B;  }
};

class Quad
{
public:
	Vertex *vert[4];
	Vector norm;

	Quad() {}
	Quad(Vertex *v0, Vertex *v1, Vertex *v2, Vertex *v3)
	{  vert[0]=v0; vert[1]=v1; vert[2]=v2; vert[3]=v3;  }
};

class Triangle
{
public:
	Vertex *vert[3];
	Vector norm;

	Triangle() {}
	Triangle(Vertex *v0, Vertex *v1, Vertex *v2)
	{  vert[0]=v0; vert[1]=v1; vert[2]=v2;  }
};


#endif