#include "nucgfx3.h"
#include <math.h>

extern const int MAX_X = 800;
extern const int MAX_Y = 600;
extern const int XRes = 800;
extern const int YRes = 600;

extern NucGFX *gfx;

////////////////////////////////////////////////////////////////////
//////////////  particle functions  ////////////////////////////////
////////////////////////////////////////////////////////////////////

unsigned char buffer[MAX_X][MAX_Y];
unsigned char bparticle[80][80];

void initparticle() 
{
	for (int k=0;k<80;k++)  { 
		for (int l=0;l<80;l++)  {

			double col=250-(14)*sqrt(0.001+double(k-40)*double(k-40)+double(l-40)*double(l-40));

			if (col<0)  col=0;

			bparticle[l][k]=(unsigned char)col;
		}
	}

}

void addparticle (int x,int y)			// color
{ 
	int  col;

	for (int k=0;k<80;k++)  { 
		for (int l=0;l<80;l++)  {

			col=int(buffer[x+l][y+k])+int(bparticle[l][k]);
	
			if (col>250) 
				buffer[x+l][y+k]=250; 
			else 
				buffer[x+l][y+k]=unsigned char(col);
		}
	}


}

void clearall() 
{

	for (int k=0;k<MAX_Y;k++) { 
		for (int l=0;l<MAX_X;l++) {
			buffer[l][k]=0;
		}
	}
}

void CalculateParticle()
{
	int i,j;

	gfx->Lock(gfx->BackBuffer);

	for(i=0; i<MAX_Y; i++)
		for(j=0; j<MAX_X; j++)
			gfx->PutPixel32(j,i,0,0,(BYTE)buffer[j][i], gfx->FrameBuffer, gfx->Pitch);

	gfx->UnLock(gfx->BackBuffer);
}
