#ifndef _TRIANGLE_H_
#define _TRIANGLE_H_

#include "rastmath.h"
#include "nucgfx3.h"


class Vertex
{
public:
	Vector pos;
	Vector norm;
	unsigned char r, g, b;

	inline Vertex()
	{  r = g = b = 255;  }
	inline Vertex(Vertex &vert)
	{  (*this) = vert;  }
	inline Vertex(float x, float y, float z)
	{  pos.x=x; pos.y=y; pos.z=z; r = g = b = 255;  }

	inline void SetColor(unsigned char R, unsigned char G, unsigned char B)
	{  r = R; g = G; b = B;  }
};


class Triangle
{
public:
	Vertex *vert[3];
	Vector norm;
	BYTE r, g, b;

	Triangle() {}
	Triangle(Vertex *v0, Vertex *v1, Vertex *v2)
	{  vert[0]=v0; vert[1]=v1; vert[2]=v2;  }
	void SetColor(BYTE R, BYTE G, BYTE B)
	{  r = R; g = G; b = B;  }
	void CalculateNormal();
};


#endif