#include "airport.h"
#include <iostream>

Employee *employees;
Flight *flights;

void data();
unsigned long login();
char menu();
void transaction();
void SeeFlights();
void PrintTicket(Passenger psngr);

/////////////////////////////////////////////
///////////////   main   ////////////////////
/////////////////////////////////////////////

void main()
{
	char action;
	unsigned long ActiveEmpNum;

	data();

	cout << "\nWelcome!\n";
	cout << "\nPress Enter to login...";
	getchar();

	ActiveEmpNum = login();
	
	cout << endl << ActiveEmpNum << endl;

	while((action=menu()) != '3')  {
		switch(action)  {
		case('1') : transaction();
		break;
		case('2') : SeeFlights();
		break;
		}
	}


	delete [] employees;			// kill 'em all

}

////////////////////////////////////////////////
//////////////////  data  //////////////////////
////////////////////////////////////////////////

void data()
{

	///////////  employees  ////////////////

	employees = new Employee[5];

	employees[0].SetUserName("rania");
	employees[0].SetPassword("aris");
	employees[0].SetEmployeeNumber(1);

	employees[1].SetUserName("amv");
	employees[1].SetPassword("asd");
	employees[1].SetEmployeeNumber(2);

	employees[2].SetUserName("nuclear");
	employees[2].SetPassword("nuke");
	employees[2].SetEmployeeNumber(3);

	employees[3].SetUserName("mot");
	employees[3].SetPassword("2cv");
	employees[3].SetEmployeeNumber(4);
	
	employees[4].SetUserName("medron");
	employees[4].SetPassword("alias");
	employees[4].SetEmployeeNumber(5);

	///////////  flights  ///////////////

	flights = new Flight[4];

	flights[0].SetFlight(1234, "athens", "thessaloniki", DC9, 70, 1100, 1150);
	flights[1].SetFlight(5678, "london", "edinburgh", BOEING767, 50, 1530, 1640);
	flights[2].SetFlight(1256, "athens", "london", BOEING727, 300, 1220, 1500);
	flights[3].SetFlight(3478, "london", "paris", AIRBUS34X, 200, 1850, 2030);

}


/////////////////////////////////////////////////
/////////////////////////////////////////////////


unsigned long login()
{
	string usern, passw;
	int i;
	bool flag;
	unsigned long empn;

	flag = false;

	do  {
		cout << "\nPlease Enter User Name: ";
		cin >> usern;
		cout << "\nPlease Enter Password: ";
		cin >> passw;

		for(i=0; i<5; i++)  {
			if (((employees+i)->UserN() == usern) && ((employees+i)->PassW() == passw))  {
				flag = true;
				empn = (employees+i)->EmployeeNum();
				cout << "\nfound\n";
			}
		}

		if (flag == false)
			cout << "\nYou have not logged in successfully\nPlease try again\n";
	}
	while (flag == false);


	return empn;
}


////////////////////////////////////////////////////

char menu()
{
	char choice;

	choice = '0';

	while ((choice < '1') || (choice > '3'))  {
		cout << "\nWelcome to the main menu";
		cout << "\n1 -- Make a transaction\n2 -- See available flights";
		cout << "\n3 -- Exit program\n";
		cin >> choice;
		getchar();
	}

	return choice;
}

/////////////////////////////////////////////////////

void transaction()
{
	unsigned int flightnum, i, freeseats;
	bool flag = false;
	Flight *CurrentFlight;
	Passenger CurrentPassenger;


	//select a flight by flightnumber

	while(flag == false)  {
		cout << "\nPlease enter Flight Number\n1234, 5678, 1256, 3478: ";
		cin >> flightnum;

		for(i=0; i<4; i++)  {
			if(flights[i].FlightNum() == flightnum)  {
				flag = true;
				CurrentFlight = &flights[i];
			}
		}
	}

	cout << "\nYou have selected the following flight: \n";
	CurrentFlight->DisplayProperties();

	freeseats = CurrentFlight->FreeS();

	if (freeseats == 0)
		cout << "\nThe flight is full. Please choose another flight.\n";
	else  {
	// register a passenger
		CurrentPassenger = CurrentFlight->RegisterPassenger();
		PrintTicket(CurrentPassenger);
	}	
}

///////////////////////////////////////////////////////////
///////////////////  seeflights  //////////////////////////
///////////////////////////////////////////////////////////

void SeeFlights()
{
	int i;

	for(i=0; i<4; i++)  {
		flights[i].DisplayProperties();
		cout << "\nPress Enter to see next flight...\n";
		getchar();
	}
}

////////////////////////////////////////////////////////////
/////////////////////  ticket  /////////////////////////////
////////////////////////////////////////////////////////////

void PrintTicket(Passenger passeng)
{
	int i, position;
	unsigned long cost=0;

	for(i=0; i<4; i++)  {
		if(position = flights[i].aboard(passeng)>=0)  {
			cout << "\nFlight  " << flights[i].FlightNum();
			cout << "\nfrom  " << flights[i].Dep() << "  to  " << flights[i].Dest();
			cout << "\nDeparture Time  " << flights[i].DepTim();
			cout << "  Arrival Time  " << flights[i].ArrTim();
			cout << "\nPosition  " << position+1;
			cout << "\nFlight Cost  " << flights[i].Pric();
			cost+=flights[i].Pric();
		}
	}

	cout << "\n\nTotal Cost  " << cost;
}
