#include "airport.h"
#include <iostream>

//////////////////////////////////////////
////////////   Person   //////////////////
//////////////////////////////////////////

void Person::SetName(string Name)
{
	this->Name = Name;
}

void Person::SetName(string Name, string Surname)
{
	this->Name = Name;
	this->Surname = Surname;
}

void Person::SetSurname(string Surname)
{
	this->Surname = Surname;
}

void Person::SetIDNumber(const IDNumber &id)
{
	IDNum.letter = id.letter;
	IDNum.number = id.number;
}

void Person::SetPassportNumber(const IDNumber &passport)
{
	Passport.letter = passport.letter;
	Passport.number = passport.number;
}

string Person::GetName() const
{
	string Name;

	cout << "\nPlease enter Passenger Name: ";
	cin >> Name;

	return Name;
}

string Person::GetSurname() const
{
	string Surname;

	cout << "\nPlease enter Passenger Surname: ";
	cin >> Surname;

	return Surname;
}

IDNumber Person::GetIDNumber() const
{
	IDNumber idnumber;

	cout << "\nPlease enter IDNumber letter: ";
	cin >> idnumber.letter;
	cout << "\nPlease enter IDNumber number: ";
	cin >> idnumber.number;

	return idnumber;
}

IDNumber Person::GetPassport() const
{
	IDNumber passport;

	cout << "\nPlease enter Passport letter: ";
	cin >> passport.letter;
	cout << "\nPlease enter Passport number: ";
	cin >> passport.number;

	return passport;
}


///////////////////////////////////////////
///////////   Passenger   /////////////////
///////////////////////////////////////////

void Passenger::SetSerialNumber(unsigned long serial)
{
	SerialNumber = serial;
}

unsigned long Passenger::GetSerialNumber() const
{
	unsigned long sn;

	cout << "\nPlease enter Passenger Serial Number: ";
	cin >> sn;

	return sn;
}

bool Passenger::operator ==(const Passenger &pas) 
{
	return	(Name == pas.Name) && 
			(Surname == pas.Surname) && 
			(Passport.letter == pas.Passport.letter) &&
			(Passport.number == pas.Passport.number) &&
			(IDNum.letter == pas.IDNum.letter) &&
			(IDNum.number == pas.IDNum.number) &&
			(SerialNum == pas.SerialNum);
}

////////////////////////////////////////////
/////////////   Employee   /////////////////
////////////////////////////////////////////

void Employee::SetEmployeeNumber(unsigned long empn)
{
	EmployeeNumber = empn;
}

void Employee::SetUserName(string username)
{
	UserName = username;
}

void Employee::SetPassword(string pass)
{
	Password = pass;
}

string Employee::GetUserName() const
{
	string username;

	cout << "\nPlease enter Employee User Name: ";
	cin >> username;

	return username;
}

string Employee::GetPassword() const
{
	string passw;

	cout << "Please enter Employee Password: ";
	cin >> passw;

	return passw;
}

unsigned long Employee::GetEmployeeNumber() const
{
	unsigned long empn;

	cout << "Please enter Employee Number: ";
	cin >> empn;

	return empn;
}


/////////////////////////////////////////////
//////////////   aeroplane   ////////////////
/////////////////////////////////////////////

Aeroplane::Aeroplane(AeroplaneType aptype)
{
	
	eAType = aptype;

	switch(aptype)  {
	case DC9 : {		sAType = "DC-9";
						ACSeats = 16;
						Crew = 5;
						AllSeats = 95;  }
	break;
	case BOEING767 : {  sAType = "BOEING 767";
						ACSeats = 36;
						Crew = 7;
						AllSeats = 182;  }
	break;
	case BOEING727 : {  sAType = "BOEING 727";
						ACSeats = 32;
						Crew = 7;
						AllSeats = 164;  }
	break;
	case BOEING737 : {  sAType = "BOEING 737";
						ACSeats = 26;
						Crew = 6;
						AllSeats = 118;  }
	break;
	case MD81 : {		sAType = "MD-81";
						ACSeats = 38;
						Crew = 8;
						AllSeats = 180;  }
	break;
	case AIRBUS34X : {  sAType = "AIRBUS 34X";
						ACSeats = 56;
						Crew = 9;
						AllSeats = 260;  }
	break;
	case AIRBUS3XX : {  sAType = "AIRBUS 3XX";
						ACSeats = 42;
						Crew = 8;
						AllSeats = 195;  }
	break;
	}
}

void Aeroplane::DisplayProperties()
{
	cout << "\nAeroplane Properties: ";
	cout << "\nAeroplane Type: " << sAType;
	cout << "\nNumber of A Class Seats: " << ACSeats;
	cout << "\nNumber Of Crew: " << Crew;
	cout << "\nTotal Number of Seats: " << AllSeats << endl;
}

AeroplaneType Aeroplane::GetType()
{
	return eAType;
}

int Aeroplane::GetACSeats()
{
	return ACSeats;
}

int Aeroplane::GetAllSeats()
{
	return AllSeats;
}


//////////////////////////////////////////////
/////////////   flight   /////////////////////
//////////////////////////////////////////////

void Flight::SetPlane(Aeroplane plane)
{
	int allseats, i;

	if(passengers)  
		delete [] passengers;

	this->plane = plane;
	allseats = plane.GetAllSeats();
	passengers = new Passenger[allseats];
	for(i=0; i<allseats; i++)
		(passengers+i)->SetSerialNumber(0);		// all SN = 0
	FreeSeats = allseats;
}

void Flight::SetFlight(unsigned int flnumber, string dep, string dest, Aeroplane plane, unsigned int price, unsigned int dt, unsigned int at)
{
	FlightNumber = flnumber;
	Departure = dep;
	Destination = dest;
	SetPlane(plane);
	Price = price;
	DepTime = dt;
	ArrTime = at;
}

Passenger Flight::RegisterPassenger()
{
	int i=0;
	string name, surname;
	char idletter, passletter;
	unsigned long idnumber, passnumber;

	while (passengers[i].SerialNum() != 0)  {
		i++;
	}
	
	cout << "\nSeat Number  " << i;
	
	cout << "\nPassenger Registration\n";
	cout << "\nName: ";
	cin >> name;
	cout << "\nSurname: ";
	cin >> surname;
	cout << "\nID letter: ";
	cin >> idletter;
	cout << "\nID Number: ";
	cin >> idnumber;
	cout << "\nPassport letter: ";
	cin >> passletter;
	cout << "\nPassport number: ";
	cin >> passnumber;

	IDNumber id(idletter, idnumber);
	IDNumber pass(passletter, passnumber);

	passengers[i].SetName(name, surname);
	passengers[i].SetSerialNumber(i+1);
	passengers[i].SetIDNumber(id);
	passengers[i].SetPassportNumber(pass);

	this->FreeSeats--;

	cout << "\nNow there are " << FreeSeats << " free seats left.\n";

	return passengers[i];
}

void Flight::DisplayProperties()
{
	cout << "\nFlight Number  " << FlightNumber;
	cout << "\nfrom  " << Departure << "  to  " << Destination;
	cout << "\nAvailable Seats  " << FreeSeats;
	cout << "\nPrice  " << Price;
	cout << "\nDeparture Time  " << DepTime << "  Arrival Time  " << ArrTime << endl;
	plane.DisplayProperties();
}


int Flight::aboard(Passenger passeng)
{
	int i=0;

	while(passengers[i].SerialNum() != 0)  {
		i++;
	}

	for(; i>=0; i--)  {
		if(passengers[i] == passeng)
			return i;
	}

	return -1;
}

