#ifndef _AIRPORT_H_
#define _AIRPORT_H_

#include <string>

using namespace std;

enum AeroplaneType {DC9, BOEING767, BOEING727, BOEING737, MD81, AIRBUS34X, AIRBUS3XX };

class IDNumber {
public:
	char letter;
	unsigned long number;

	IDNumber() {}
	IDNumber(char ltr, unsigned long num)
	{letter = ltr; number = num;}

};

///////////////////////////////////////////////
//////////// Base class Person ////////////////
///////////////////////////////////////////////
class Person {
protected:
	string Name, Surname;
	IDNumber IDNum, Passport;

public:
	virtual void SetName(string Name);
	virtual void SetName(string Name, string Surname);
	virtual void SetSurname(string Surname);
	virtual void SetIDNumber(const IDNumber &id);
	virtual void SetPassportNumber(const IDNumber &passport);
	virtual string GetName() const;
	virtual string GetSurname() const;
	virtual IDNumber GetIDNumber() const;
	virtual IDNumber GetPassport() const;
};

//////////////////////////////////////////////
// class Passenger, derived from BC Person //
//////////////////////////////////////////////
class Passenger : public Person {
protected:
	unsigned long SerialNumber;

public:
	void SetSerialNumber(unsigned long serial);
	unsigned long GetSerialNumber() const;
	unsigned long SerialNum()
	{  return SerialNumber;  }
	bool operator ==(const Passenger &pas);
};


////////////////////////////////////////////
// class Employee, derived from BC Person //
////////////////////////////////////////////
class Employee : public Person {
protected:
	string UserName, Password;
	unsigned long EmployeeNumber;

public:
	Employee() {}
	void SetEmployeeNumber(unsigned long empn);
	void SetUserName(string username);
	void SetPassword(string pass);
	string GetUserName() const;
	string GetPassword() const;
	unsigned long GetEmployeeNumber() const;
	string UserN()  { return UserName; }
	string PassW()  { return Password; }
	unsigned long EmployeeNum()  { return EmployeeNumber; }
};


////////////////////////////////////////////////
/////////////   class aeroplane   //////////////
////////////////////////////////////////////////

class Aeroplane
{
private:
	string sAType;
	AeroplaneType eAType;
	int ACSeats, Crew, AllSeats;
public:
	Aeroplane() {}
	Aeroplane(AeroplaneType aptype);
	void DisplayProperties();
	AeroplaneType GetType();
	int GetACSeats();
	int GetAllSeats();
};

///////////////////////////////////////////////
///////////////   class flight   //////////////
///////////////////////////////////////////////

class Flight
{
private:
	unsigned int FlightNumber;
	string Departure, Destination;
	Passenger *passengers;
	Aeroplane plane;
	unsigned int Price, DepTime, ArrTime;
	unsigned int FreeSeats;
public:
	void SetPlane(Aeroplane plane);
	
	Flight()
	{  passengers = NULL;  }
	
	void SetFlight(unsigned int flnumber, string dest, string dep, Aeroplane plane, unsigned int pr, unsigned int dt, unsigned int at);
	
	string Dep()
	{  return Departure;  }

	string Dest()
	{  return Destination;  }

	unsigned int FlightNum()
	{  return FlightNumber;  }

	unsigned int FreeS()
	{  return FreeSeats;  }

	Aeroplane Plane()
	{  return plane;  }

	unsigned int Pric()
	{  return Price;  }

	unsigned int DepTim()
	{  return DepTime;  }

	unsigned int ArrTim()
	{  return ArrTime;  }

	void DisplayProperties();

	void ShowPassengers();

	Passenger RegisterPassenger();

	int aboard(Passenger passeng);

};


#endif //_AIRPORT_H_