void DrawFlat(Triangle *tr, BYTE *buffer, long pitch)
{
	int scanlines, i, j, starty;
	double d01, d02, d12;
	float dx, dy, slope, startx;
	Vertex *vert1, *vert2;

	int topy=WINDOWY;
	for(i=0; i<3; i++) {
		int tmp = tr->vert[i]->pos.y;
		if(tmp < topy) topy = tmp;
	}

	d01 = (tr->vert[0]->pos.y-tr->vert[1]->pos.y > 0) ? (tr->vert[0]->pos.y-tr->vert[1]->pos.y) : (tr->vert[1]->pos.y-tr->vert[0]->pos.y);
	d02 = (tr->vert[0]->pos.y-tr->vert[2]->pos.y > 0) ? (tr->vert[0]->pos.y-tr->vert[2]->pos.y) : (tr->vert[2]->pos.y-tr->vert[0]->pos.y);
	d12 = (tr->vert[1]->pos.y-tr->vert[2]->pos.y > 0) ? (tr->vert[1]->pos.y-tr->vert[2]->pos.y) : (tr->vert[2]->pos.y-tr->vert[1]->pos.y);
	
	scanlines = (d01>d02) ? (int)d01 : (int)d02;			// scanlines - greater of d01, d02
	scanlines = (scanlines>d12) ? scanlines : (int)d12;

	int *LeftX = new int[scanlines];
	int *RightX = new int[scanlines];

	_asm {
		mov edi, LeftX
		mov ecx, scanlines
		mov eax, WINDOWX-1		// *corr* winx - 1 oxi sketo winx
		rep stosd

		mov edi, RightX
		mov ecx, scanlines
		xor eax, eax
		rep stosd
	}	

	for(j=0; j<3; j++)  {
		vert1 = tr->vert[j];
		vert2 = tr->vert[(j+1)%3];
		startx = vert1->pos.x;
		int starty;
		int sx;

		if(vert1->pos.y>vert2->pos.y)  {
			dx = startx - vert2->pos.x;
			dy = vert1->pos.y - vert2->pos.y;
			starty = (int)vert2->pos.y;
			sx = (int)vert2->pos.x;
		}
		else  {
			dx = vert2->pos.x - startx;
			dy = vert2->pos.y - vert1->pos.y;
			starty = (int)vert1->pos.y;
			sx = (int)vert1->pos.x;
		}

		slope = dx/dy;

		int ylines = (int)dy;
		for(i=0; i<ylines; i++)  {
			int calcx = int(slope*i + sx);
			int y = i+starty-topy;
			if(calcx<LeftX[y])
				LeftX[y] = calcx;
			if(calcx>RightX[y])
				RightX[y] = calcx;
		}
	}

	starty = (tr->vert[0]->pos.y<tr->vert[1]->pos.y) ? (int)tr->vert[0]->pos.y : (int)tr->vert[1]->pos.y;
	starty = (starty<tr->vert[2]->pos.y) ? starty : (int)tr->vert[2]->pos.y;
	
	for(j=0; j<scanlines; j++)  {
		for(i=LeftX[j]; i<RightX[j]; i++) {
			gfx->PutPixel((WORD)i, (WORD)(starty+j),0, 0, 255, buffer, pitch);
		}
	}

	delete [] LeftX;
	delete [] RightX;
}