#define WIN32_LEAN_AND_MEAN
#define WINDOWX	400
#define WINDOWY	300

#define STATE_INIT	0
#define STATE_MAIN	1
#define STATE_QUIT	2

#define SizeX 800
#define SizeY 600
#define BPP 32

#define BN 10

#define MAX_X 400
#define MAX_Y 1700
#define SCR 300

#include <windows.h>
#include <math.h>
#include "nucgfx3.h"

LRESULT CALLBACK WinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

void Init();
void Main();
void CleanUp();

HWND hWnd;
int State = STATE_INIT;


int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR CmdLine, int ShowCmd) {

	MSG msg;
	WNDCLASSEX wc;
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_VREDRAW | CS_HREDRAW;
	wc.lpfnWndProc = WinProc;
	wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   wc.hInstance = hInst;
   wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
   wc.hIconSm = wc.hIcon;
   wc.hCursor = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
   wc.lpszMenuName = NULL;
   wc.lpszClassName = "NucWin";
   RegisterClassEx(&wc);

   hWnd = CreateWindowEx(	NULL,
   								"NucWin",
                           "Simple Window ...ayta",
                           NUCGFX_WINDOWSTYLE_FULLSCREEN,
                           (GetSystemMetrics(SM_CXSCREEN)-WINDOWX)/2,
                           (GetSystemMetrics(SM_CYSCREEN)-WINDOWY)/2,
                           WINDOWX, WINDOWY,
                           NULL,
                           NULL,
                           hInst,
                           NULL );
   ShowWindow(hWnd, ShowCmd);
   UpdateWindow(hWnd);

   Init();
   State = STATE_MAIN;

   while(1) {
   	if(PeekMessage(&msg, NULL, 0,0, PM_REMOVE)) {
      	if(msg.message == WM_QUIT) break;
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      } else {
      	// main loop
         if(State == STATE_MAIN) Main();
      }
   }
   return msg.wParam;
}

LRESULT CALLBACK WinProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {

	switch(msg) {
	case WM_KEYDOWN:
   	if(wParam == VK_ESCAPE) {
      	PostMessage(hWnd, WM_CLOSE, 0, 0);
         return 0;
      }
	break;

	case WM_CLOSE:
   		State = STATE_QUIT;
   		CleanUp();
   		DestroyWindow(hWnd);
		return 0;
	break;

	case WM_DESTROY:
   		PostQuitMessage(0);
	break;

	default: break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

NucGFX *gfx;
NucGFXSurface *surf;

void Init() 
{

	RECT topr, bottomr;

	gfx = new NucGFX(SizeX, SizeY, BPP, NUCGFX_FULLSCREEN, 2);
	ShowCursor(FALSE);
	gfx->CreateSurface(MAX_X, MAX_Y, &surf);
	gfx->LoadBMP("4scroll.bmp", surf);
	
	topr.top = 0;
	topr.left = 0;
	topr.right = MAX_X;
	topr.bottom = SCR;
	
	bottomr.top = MAX_Y - SCR;
	bottomr.left = 0;
	bottomr.right = MAX_X;
	bottomr.bottom = MAX_Y;

	gfx->Blt(bottomr, surf, topr, surf);
}

void CleanUp() 
{
	gfx->ReleaseSurface(surf);
	delete gfx;
}


int count = 0;

void Main() 
{

	RECT desr, bbr;

    // main2
	
	desr.left = 0;
	desr.right = MAX_X;
	desr.top = count% (MAX_Y - SCR);
	desr.bottom = desr.top + SCR;

	bbr.top = 0;
	bbr.left = 0;
	bbr.right = SizeX;
	bbr.bottom = SizeY;

	gfx->Blt(bbr, gfx->BackBuffer, desr, surf);

	gfx->Flip();

	count++;

}
